#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include "pngio.h"

FILE *open_file(char *fn,char *mode)
{
  FILE *f;
  f= fopen(fn,mode);
  if (!f) exit(fprintf(stderr,"can't open %s: %s\n",fn, strerror(errno)));
  return f;
}

int main(int argc,char **argv)
{
  int mode,i;
  FILE *ifile, *ofile;
  char *ifn, *ofn;
  unsigned int w,h,*data;
  char *e;

  if (argc<4) exit(fprintf(stderr,"usage: %s [e|d] infile outfile (width height)\n",argv[0]));

  mode= strcmp(argv[1],"d");

  ifile= ofile= NULL;
  ifn= argv[2];
  ofn= argv[3];

  if (mode) // encoding
  {
    int i;
    ofile= open_file(ofn,"wb");
    e= read_png_image(ifn,&w,&h,&data);
    if (e) exit(fprintf(stderr,"can't read %s: %s\n",ifn,e));
    for(i=0;i<w*h;i++)
    {
      unsigned char P[4];
      P[0]= data[i] >> 16;
      P[1]= data[i] >> 8;
      P[2]= data[i];
      P[3]= data[i] >> 24;
      fwrite(P,1,4,ofile);
    }
  } else {
    unsigned char *bdata;
    ifile= open_file(ifn,"rb");

    if (argc>4) w= atoi(argv[4]); else w= 800; 
    if (argc>5) h= atoi(argv[5]); else h= 480;
    
    bdata= malloc(w*h*4);
    fread(bdata, 1, w*h*4,ifile);
    data= malloc(w*h*4);
    for(i=0;i<w*h;i++)
    {
       data[i]= (bdata[4*i+2]<<16) | (bdata[4*i+1]<<8) | bdata[4*i+0] | (bdata[4*i+3]<<24);
    }
    e= write_png_image(ofn, w,h,data);
    if (e) exit(fprintf(stderr,"can't write %s: %s\n",ofn,e));
  }
  if (ifile) fclose(ifile);
  if (ofile) fclose(ofile);
  return 0;
}
